//Image Datablock
datablock DecalData(ShuttingDown)
{
	textureName = "Add-Ons/Server_Shutdown/ShuttingDown.png";
};

//Check if user has Server_AutoSaver
%ascheck = ForceRequiredAddOn("Server_AutoSaver");
if(%ascheck == $Error::AddOn_NotFound)
	$Shutdown::HasAutoSaver = 0;
else
	$Shutdown::HasAutoSaver = 1;
	
//RTB Prefs
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook)
	{
		if(isFile("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs"))
			exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
		else
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	}
	
	RTB_registerPref("Display Image","Shutdown","Shutdown::DisplayImage","bool","Server_Shutdown",1,0,0);
	if($Shutdown::HasAutoSaver == 1)
		RTB_registerPref("AutoSave on Shutdown","Shutdown","Shutdown::Save","bool","Server_Shutdown",1,0,0);
	RTB_registerPref("Command Restriction", "Shutdown", "Shutdown::Restriction","list Nobody 1 Admin 2 Super-Admin 3 Host 4","Server_Shutdown", 4, 0, 0);
	RTB_registerPref("Shutdown Setting", "Shutdown", "Shutdown::Setting","list Kick Players and Password 1 End Server 2","Server_Shutdown", 2, 0, 0);
	RTB_registerPref("Set Password to (If Desired)", "Shutdown", "Shutdown::Password", "string 180", "Server_Shutdown", "password", 0, 0);
}
else
{
	//Non-RTB Prefs
	$Shutdown::DisplayImage = 1;
	if($Shutdown::HasAutoSaver == 1)
		$Shutdown::Save = 1;
	$Shutdown::Restriction = 4;
	$Shutdown::Setting = 2;
	$Shutdown::Password = "password";
}

function serverCmdShutdown(%client)
{
	if($Shutdown::Restriction == 1)
		%restriction = "%client.bl_id == 0";
	if($Shutdown::Restriction == 2)
		%restriction = "%client.isAdmin";
	if($Shutdown::Restriction == 3)
		%restriction = "%client.isSuperAdmin";
	if($Shutdown::Restriction == 4)
		%restriction = "%client.bl_id == getNumKeyID() || %client.isLocalConnection()";
	if(%restriction)
	{
		if($Shutdown::DisplayImage == 1)
		{
		CenterPrintAll("<bitmap:Add-Ons/Server_Shutdown/ShuttingDown.png>", 10);
		}
		messageAll('MsgAdminForce',"<font:Palatino Linotype:25>\c0The server will shut down in \c610 \c0seconds.");
		echo("Shutdown: Command initiated. Server de-activating in 10 seconds.");
		schedule(1000,0,messageAll,'MsgClientJoin',"<font:Palatino Linotype:25>\c0The server will shut down in \c69 \c0seconds.");
		schedule(2000,0,messageAll,'MsgClientJoin',"<font:Palatino Linotype:25>\c0The server will shut down in \c68 \c0seconds.");
		schedule(3000,0,messageAll,'MsgClientJoin',"<font:Palatino Linotype:25>\c0The server will shut down in \c67 \c0seconds.");
		schedule(4000,0,messageAll,'MsgClientJoin',"<font:Palatino Linotype:25>\c0The server will shut down in \c66 \c0seconds.");
		if($Shutdown::HasAutoSaver == 1 && $Shutdown::Save == 1)
		{
			messageAll('',"<font:Palatino Linotype:25>\c6Autosaving before shutdown.");
			AutoSaver_saveBricks(fileBase($AutoSaver::SaveFile),!!$AutoSaver::SaveEvents,!!$AutoSaver::SaveOwnership);
		}
		schedule(5000,0,messageAll,'MsgClientJoin',"<font:Palatino Linotype:25>\c0The server will shut down in \c65 \c0seconds.");
		schedule(6000,0,messageAll,'MsgClientJoin',"<font:Palatino Linotype:25>\c0The server will shut down in \c64 \c0seconds.");
		schedule(7000,0,messageAll,'MsgClientJoin',"<font:Palatino Linotype:25>\c0The server will shut down in \c63 \c0seconds.");
		schedule(8000,0,messageAll,'MsgClientJoin',"<font:Palatino Linotype:25>\c0The server will shut down in \c62 \c0seconds.");
		schedule(9000,0,messageAll,'MsgClientJoin',"<font:Palatino Linotype:25>\c0The server will shut down in \c61 \c0seconds.");
		schedule(10000,0,messageAll,'MsgClientJoin',"<font:Palatino Linotype:25>Kicking players.");
		schedule(15000,0,echo,"Shutdown: Kicking players.");
		schedule(10000,0,shutDown);
		schedule(15000,0,messageAll,'MsgClientJoin',"<font:Palatino Linotype:25>De-activating game server.");
		schedule(15000,0,echo,"Shutdown: De-activating game server.");
		if($Shutdown::Setting == 2)
		{
			//schedule(15000,0,quit);
		}
	}
	else
	{
		if($Shutdown::Restriction == 1)
			messageClient(%client, '',"\c6Shutdown disabled.");
		if($Shutdown::Restriction == 2)
			messageClient(%client, '',"\c6Only Admins may stop the server.");
		if($Shutdown::Restriction == 3)
			messageClient(%client, '',"\c6Only Super-Admins may stop the server.");
		if($Shutdown::Restriction == 4)
			messageClient(%client, '',"\c6Only the host may stop the server.");
	}
}